//  ** Revision History **
//  14-Jan-1993 (AH) Release 1.0.0.000
//  13-Jan-1993 (AH) solved problem with unload hang in VB-2.0
//  28-Dec-1992 (AH) Problem with CtlName fixed
//  21-Nov-1992 (AH) PictureDrawStyle problem fixed
//  15-Oct-1992 (AH) Get-, Set- and Check- property moved out of mainbody.
//  15-Oct-1992 (AH) Button... properties no longer shown in designmode.
//  15-Oct-1992 (AH) ColorBar added.
//  02-Oct-1992 (AH) Fixed problem with sizing/position
//  19-Sep-1992 (AH) Alignment fixed
//  19-Sep-1992 (AH) Ready for debugging
//  02-Sep-1992 (AH) Prehistory
//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         Tools.c  (part of EuroTools project)
//   
// PURPOSE:      Make a toolbar window
//   
// COMMENTS:     
//   
//****************************************************************************                    


#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "estools.h"  

#include "version.h"
#include <string.h>
#define  CTL_DATA       // To declare static data in frame.h
#include "tools.h"
#include "vb1.h"		// Support for Visual Basic 1.0
#include "vb2.h"		// Support for Visual Basic 2.0
#include "helpid.h"


//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;
extern USHORT VBVersion;     
BOOL	recreate;   // true during recreation
HANDLE	ghWndTool;	// handle for hWnd of Control

//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawTool(HCTL hctl, HWND hWnd, HDC hDC);
VOID NEAR RecalcAreaTool(HCTL hctl, HWND hWnd);
VOID NEAR MButtonDown(HCTL hctl, HWND hWnd, POINT pt);
VOID NEAR MButtonUp(HCTL hctl, HWND hWnd, POINT pt);
SHORT NEAR GetButtonIndex(HCTL hctl, HWND hWnd, POINT pt);
VOID NEAR MouseMove(HCTL hctl, HWND hWnd, POINT pt);
VOID NEAR GroupUp(HCTL hctl, PGLOBALTOOL gb, SHORT index);
VOID NEAR DrawPicture(HDC hDC, LPRECT lprect, HPIC hpic, int drawstyle);
LONG NEAR GetProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp); 
LONG NEAR SetProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp);
LONG NEAR CheckProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp);

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export ToolsCtlProc(HCTL hctl, HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Tool Control Procedure     
//
//      COMMENTS:        
//
//**************************************************************************

LONG FAR PASCAL _export ToolsCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult; 
    PTOOL       ptool;
    
    // Message pre-processing
    switch (msg) 
    { 
        case WM_NCCREATE: 
        {
        	// Here, initialize preHwnd things.
            LONG	style;
            
            style = GetWindowLong(hWnd, GWL_STYLE);
                
            // TitleBar
            if (TOOLDEREF(hctl)->TitleBar) 
            { 
            	style = style | WS_CAPTION;
                style = style ^ WS_MAXIMIZEBOX;
            	if (TOOLDEREF(hctl)->MinButton)            
                	style = style | WS_MINIMIZEBOX;
                if (TOOLDEREF(hctl)->ControlBox)      
                    style = style | WS_SYSMENU;
            }               
            // Set the new style
            style = SetWindowLong(hWnd, GWL_STYLE, style);
        }    
        break;           
        
         
        case WM_CREATE: 
        {
            if (!recreate) 
            {
            	ptool = TOOLDEREF(hctl);
            	ptool->Light3DColor = WHITE;
            	ptool->Dark3DColor = DARKGREY;
                ptool->Rows = TOOL_DEFAULTROWS;
                ptool->Columns = TOOL_DEFAULTCOLUMNS;
                ptool->ButtonHeight = TOOL_BUTTON_DEFAULTHEIGHT;
                ptool->ButtonWidth = TOOL_BUTTON_DEFAULTWIDTH;
                ptool->NonToggledDown = 0;  
                ptool->PictureDrawStyle = TOOLDRAWSTYLESTRETCHED;
                                                             
#ifndef RUNTIMEVERSION                
                // set the property text for the About dialog
            	SetAboutText(hctl, IPROP_TOOL_ABOUT);           
#endif
                                                        
            	VBSetControlProperty(hctl, IPROP_TOOL_BACKCOLOR, 
                	                       TOOL_BACKGROUND_DEFAULT);
            
            	// allocate global space for the buttons
            	// to make thing simple we allocate space for max # of buttons
                // GHND = MOVEBLE and ZEROINIT
            	if(!(ptool->gButtons = GlobalAlloc(GHND, (sizeof(GLOBALTOOL)*TOOL_MAXSIZE))))
            		return -1; // out of memory
        	}
            recreate = FALSE;
        }
        break;
                
        case VBM_CREATED: 
        {
            HPIC	hpic; 
            PIC		pic;
                    
            // everything is loaded
            TOOLDEREF(hctl)->CCLoaded = TRUE;
            	
            //Set Icon
        	hpic = TOOLDEREF(hctl)->Icon;
            VBGetPic(hpic, &pic);
            if (pic.picType == PICTYPE_ICON)
            	SetClassWord(hWnd, GCW_HICON, pic.picData.icon.hicon);                
        }    
        break;

#ifndef RUNTIMEVERSION  
        
		case VBM_HELP:
	    	switch (LOBYTE(wp))
			{
				case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_TOOL_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_TOOL_BUTTONALLUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonallup);
			    		return 0L;                                                        
                
                	case IPROP_TOOL_BUTTONENABLED:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonenabled);
			    		return 0L; 
            	
                	case IPROP_TOOL_BUTTONFOCUS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonfocus);
			    		return 0L;                                            
            
            		case IPROP_TOOL_BUTTONGROUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttongroup);
			    		return 0L;                                            
            
            		case IPROP_TOOL_BUTTONHEIGHT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonheight);
			    		return 0L;                                            
            
            		case IPROP_TOOL_BUTTONPICDISABLED:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonpicdisabled);
			    		return 0L;                                            
            
            		case IPROP_TOOL_BUTTONPICDOWN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonpicdown);
			    		return 0L;                                            
            
            		case IPROP_TOOL_BUTTONPICUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonpicup);
			    		return 0L;                                       
            
            		case IPROP_TOOL_BUTTONTOGGLED:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttontoggled);
			    		return 0L;                                      
            
            		case IPROP_TOOL_BUTTONVALUE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonvalue);
			    		return 0L;                                           
            
            		case IPROP_TOOL_BUTTONWIDTH:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttonwidth);
			    		return 0L;                                        
            
            		case IPROP_TOOL_COLUMNS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_columns);
			    		return 0L;                                             
            
                	case IPROP_TOOL_CONTROLBOX:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_controlbox);
			    		return 0L;                                             
                        
            		case IPROP_TOOL_DARK3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_dark3dcolor);
			    		return 0L;                                             
                        
            		case IPROP_TOOL_HWND:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_hwnd);
			    		return 0L;                                                
                    
                	case IPROP_TOOL_LIGHT3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_light3dcolor);
			    		return 0L;                                             
                        
            		case IPROP_TOOL_MINBUTTON:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_minbutton);
			    		return 0L;                                       
                    
					case IPROP_TOOL_PICTUREDRAWSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturedrawstyle);
			    		return 0L;                                             
                              
                	case IPROP_TOOL_ROWS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_rows);
			    		return 0L;                                            
                     
                	case IPROP_TOOL_TITLEBAR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_titlebar);
			    		return 0L;                                      
                                                                             
                	case IPROP_TOOL_WINDOWSTATE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_windowstate);
			    		return 0L;
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, estools);
		    return 0L;
		}
		break;                                   
                      
        case VBM_INITPROPPOPUP:
        	switch (wp) 
            {
	    		case IPROP_TOOL_ABOUT:
                	hctlDialog  = hctl;
                	ipropDialog = wp;
                	return (LONG)HwndInitAboutPopup();
        
        		case IPROP_TOOL_DARK3DCOLOR:
        		case IPROP_TOOL_LIGHT3DCOLOR:
            		if (VBVersion < 0x0200) 
            		{
            			hctlDialog  = hctl;
            			ipropDialog = wp;
            			return (LONG)HwndInitColorPopup();
        			}
        	}
        	break; 

#endif                
        case VBM_SAVEPROPERTY: 
        {  
            PGLOBALTOOL	gb;
        	ERR		rv;  
            
            if (wp == IPROP_TOOL_GLOBAL) 
            {
                gb = (PGLOBALTOOL) GlobalLock((GLOBALHANDLE)TOOLDEREF(hctl)->gButtons);
                rv = VBWriteFormFile((HFORMFILE)lp, (LPVOID)gb, sizeof(GLOBALTOOL)*TOOL_MAXSIZE);
            	GlobalUnlock(TOOLDEREF(hctl)->gButtons);
            	return rv;
            }
        }
        break;
                              
        case VBM_LOADPROPERTY: 
        {                
            PGLOBALTOOL	gb;
        	ERR		rv;
            if (wp == IPROP_TOOL_GLOBAL) 
            {
                gb = (PGLOBALTOOL) GlobalLock((GLOBALHANDLE)TOOLDEREF(hctl)->gButtons);
        		rv = VBReadFormFile((HFORMFILE)lp, (LPVOID)gb, sizeof(GLOBALTOOL)*TOOL_MAXSIZE);     	    
            	GlobalUnlock(TOOLDEREF(hctl)->gButtons);
            	return rv;
            }        
        }
        break;
        
		case WM_SETFOCUS:
            SendMessage(hWnd, WM_NCACTIVATE, TRUE, 0);
            BringWindowToTop(hWnd); 
            InvalidateRect(hWnd, NULL, TRUE);
            break;
                                                
        case WM_KILLFOCUS:
            SendMessage(hWnd, WM_NCACTIVATE, FALSE, 0);
            InvalidateRect(hWnd, NULL, TRUE);
            break;
        
        case WM_NCLBUTTONDOWN:    
            SetFocus(hWnd);
            break; 
        
        case WM_ERASEBKGND:
            // Don't bother with erasing the background
            return TRUE;
         
        case WM_KEYDOWN: 
        {
            PGLOBALTOOL	gb; 
            
            ptool = TOOLDEREF(hctl);        
            gb = (PGLOBALTOOL)GlobalLock(ptool->gButtons);
                           
            switch (wp) 
            {  
                case VK_SPACE:
                    if (gb[ptool->ButtonFocus].Value != BUTTONDISABLED) 
                    { 
                        if (gb[ptool->ButtonFocus].fToggled) 
                        {
                            if (!gb[ptool->ButtonFocus].fAllUp) 
                            {
                            	gb[ptool->ButtonFocus].Value = BUTTONDOWN;    
                            }   
                        	else 
                            { 
                            	gb[ptool->ButtonFocus].Value =
                                	gb[ptool->ButtonFocus].Value ? BUTTONUP : BUTTONDOWN;
                        	}       
                        }    
                        else 
                        	gb[ptool->ButtonFocus].Value = BUTTONDOWN;
                        // fire click event
                        VBFireEvent(hctl, EVENT_TOOL_CLICK, NULL);
                    }    
                    break;
                
        		case VK_LEFT:
                	if (ptool->ButtonFocus > 0)
                		ptool->ButtonFocus -= 1;
                    break;
                    
            	case VK_RIGHT:
                	if (ptool->ButtonFocus < (ptool->Rows * ptool->Columns-1))
                		ptool->ButtonFocus += 1;
                    break;
            
            	case VK_UP:
                	if (ptool->ButtonFocus >= ptool->Columns)
                    	ptool->ButtonFocus -= ptool->Columns; 
                    break;
            
            	case VK_DOWN:
                	if (ptool->ButtonFocus < (ptool->Rows*(ptool->Columns-1)))
                    	ptool->ButtonFocus += ptool->Columns;                                        
                    break;
            }                                   
            GlobalUnlock(ptool->gButtons);
            InvalidateRect(hWnd, NULL, TRUE);
        }
        break; 
        
        case WM_KEYUP: 
        {
            PGLOBALTOOL	gb; 
            
            ptool = TOOLDEREF(hctl);        
            gb = (PGLOBALTOOL)GlobalLock(ptool->gButtons);
                           
            switch (wp) 
            {
        		case VK_SPACE:                        
                    if (gb[ptool->ButtonFocus].Value != BUTTONDISABLED) 
                    {
                    	if (!gb[ptool->ButtonFocus].fToggled) 
                        {
                                gb[ptool->ButtonFocus].Value =
                                	gb[ptool->ButtonFocus].Value ? BUTTONUP : BUTTONDOWN;
                    	}
                    	GroupUp(hctl, gb, (SHORT)ptool->ButtonFocus);
                    }    
                    break;
            } 
            GlobalUnlock(ptool->gButtons);
            InvalidateRect(hWnd, NULL, TRUE);
        }
    	break;
        
        case WM_RBUTTONDBLCLK: 
            if (VBGetMode() == MODE_DESIGN) 
            {
            	WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, estools);
            	return OK;
            }
            else
                break;    
            
        case WM_LBUTTONDBLCLK:
        case WM_LBUTTONDOWN: 
        { 
            POINT	pt;
        
            pt.x = LOWORD(lp);
            pt.y = HIWORD(lp);
            SetFocus(hWnd);
            SetCapture(hWnd);
            MButtonDown(hctl, hWnd, pt);
        	InvalidateRect(hWnd, NULL, TRUE);
            VBFireEvent(hctl, EVENT_TOOL_CLICK, NULL);
        }
        return OK;
        
        case WM_LBUTTONUP: 
        { 
            POINT	pt;
        	
            pt.x = LOWORD(lp);
            pt.y = HIWORD(lp);
            SetFocus(hWnd); 
            MButtonUp(hctl, hWnd, pt);
        	InvalidateRect(hWnd, NULL, TRUE);
            ReleaseCapture();                
        } 
        return OK;
            
        case WM_MOUSEMOVE: 
        {
            POINT	pt; 
            
            pt.x = LOWORD(lp);
            pt.y = HIWORD(lp);    
            MouseMove(hctl, hWnd, pt);
        }
        break;
        
        case WM_SETFONT:
            ptool = TOOLDEREF(hctl);
            ptool->hfont = (HFONT)wp;
            return(0L);

        case WM_GETFONT:
            ptool = TOOLDEREF(hctl);
            return (ptool->hfont);

        case WM_SETTEXT: 
        {
            HSZ hsz;

            ptool = TOOLDEREF(hctl);
            if (ptool->hszCaption) 
            {
                VBDestroyHsz(ptool->hszCaption);
            }
            hsz = VBCreateHsz((_segment)hctl, (LPSTR)lp);
            ptool = TOOLDEREF(hctl);
            ptool->hszCaption = hsz;
             
            //SetWindowText(hWnd, (LPSTR)VBDerefHsz(hsz));
            InvalidateRect(hWnd, NULL, TRUE);
        }    
        return(0L);      
     
        case WM_GETTEXT: 
        {    
            LPSTR   lpstr;
            WORD    cch;

            ptool = TOOLDEREF(hctl);
            if (ptool->hszCaption == NULL) 
            {
                *(LPSTR)lp = 0L;
                wp = 1;
            }
            else 
            {
                lpstr = VBDerefHsz(ptool->hszCaption);
                cch = lstrlen(lpstr) + 1;
                if (wp > cch)
                    wp = cch;
                _fstrncpy((LPSTR)lp, lpstr, wp);
                ((LPSTR)lp)[wp - 1] = '\0';
            }
        }
        return (LONG)(wp - 1);

        case WM_GETTEXTLENGTH:
            ptool = TOOLDEREF(hctl);
            if (ptool->hszCaption == NULL) 
            {
                return(0L);
            }    
            else
                return (lstrlen(VBDerefHsz(ptool->hszCaption)));    
                
        case WM_SIZE: 
            if (wp != SIZE_MINIMIZED)
            	RecalcAreaTool(hctl, hWnd); 
            break;
            
        case WM_PAINT:
            if (!IsIconic(hWnd)) 
            {
            	if (wp)
                	DrawTool(hctl, hWnd, (HDC)(wp));
            	else 
                {
                	PAINTSTRUCT     ps;

                	BeginPaint(hWnd, &ps);
                	DrawTool(hctl, hWnd, ps.hdc);
                	EndPaint(hWnd, &ps);
            	}
            }
            break;
        
        
        
        case VBM_GETPROPERTY:
			return GetProperty(hctl, hWnd, msg, wp, lp);            
        
        case VBM_SETPROPERTY:
            return SetProperty(hctl, hWnd, msg, wp, lp);

        case VBM_CHECKPROPERTY:
            return CheckProperty(hctl, hWnd, msg, wp, lp);
    }

    // Default processing
    
    if (wp != VBM_GETPROPERTY && 
        wp != VBM_SETPROPERTY &&
    	wp != VBM_CHECKPROPERTY)
    	lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) 
    {
        case WM_DESTROY: 
        {
            int	i;
            PGLOBALTOOL	  gb;
            
            ptool = TOOLDEREF(hctl); 
        	if (!recreate) 
            {
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
        		VBFreePic(TOOLDEREF(hctl)->Icon);      
                // free pictures
                for (i=0; i<TOOL_MAXSIZE; i++) 
                {
                	if (gb[i].hpicUp) VBFreePic(gb[i].hpicUp);  
                    if (gb[i].hpicDown) VBFreePic(gb[i].hpicDown);
                    if (gb[i].hpicDisabled) VBFreePic(gb[i].hpicDisabled);
                }  
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
            	// Free global storage
            	ptool = TOOLDEREF(hctl);
            	if (!GlobalFree(ptool->gButtons))
                    return -1;
                return OK;
            }
        }
        break;
    }
    return lResult;
}
            
//**************************************************************************
//
//   FUNCTION:	LONG NEAR GetProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)	
//
//   PURPOSE:	Get property value.
//
//
//
//   COMMENT:	fetch a property value
//
//
//   
//
//                     Copyright (C) EuroSource AB 1992-1995
//************************************************************************* 

LONG NEAR GetProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{ 
	switch (wp) 
    {
    	case IPROP_TOOL_BUTTONVALUE: 
        {
        	LONG          i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
          	i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            lpDs->data = (LONG)gb[i].Value;
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
        }
        return OK;
                
        case IPROP_TOOL_BUTTONTOGGLED: 
        {
            LONG	i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
            i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            if (gb[i].fToggled)
            	lpDs->data = -1; // return TRUE
            else    
                lpDs->data = (LONG)gb[i].fToggled;
                    
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
        }
        return OK;
                    
        case IPROP_TOOL_BUTTONALLUP: 
        {
            LONG	i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
           	i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            if (gb[i].fAllUp)
                lpDs->data = -1; // return TRUE
            else    
                lpDs->data = (LONG)gb[i].fAllUp;
                    
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
        }
        return OK; 
                
        case IPROP_TOOL_BUTTONENABLED: 
        {
            LONG	i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
            i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            if (gb[i].Value == BUTTONDISABLED)
                lpDs->data = FALSE;
            else
                lpDs->data = -1; //VB TRUE
                    
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
        }
        return OK;            
                
        case IPROP_TOOL_BUTTONGROUP: 
        {
            LONG	i;
         	LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
            i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            lpDs->data = (LONG)gb[i].Group;
                    
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
        }
        return OK;
                    
        case IPROP_TOOL_BUTTONPICUP: 
        {
        	LONG	i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
            i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            lpDs->data = (LONG)gb[i].hpicUp;
            
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
        }
        return OK;         
                
        case IPROP_TOOL_BUTTONPICDOWN: 
        {
        	LONG i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
            i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            lpDs->data = (LONG)gb[i].hpicDown;
            
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
     	}
        return OK;
                                                     
        case IPROP_TOOL_BUTTONPICDISABLED: 
        {
        	LONG	i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PGLOBALTOOL	gb;
                    
            gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
            i = lpDs->index[0].data;
                    
            if (i >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            lpDs->data = (LONG)gb[i].hpicDisabled;
                    
            GlobalUnlock(TOOLDEREF(hctl)->gButtons);
     	}
        return OK;
                
        case IPROP_TOOL_ICON:
        {    
        	if (IsIconic(hWnd))
            	*(LPINT)lp = 1;
            else
                *(LPINT)lp = 0;
        }    
        return OK;           
    
    	case IPROP_TOOL_HWND:
	    
			ghWndTool = VBGetControlHwnd(hctl);
			(HWND *)lp = &ghWndTool; 
			return OK;
	}
	return VBDefControlProc(hctl, hWnd, msg, wp, lp);
}

//**************************************************************************
//
//   FUNCTION:	LONG NEAR SetProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)	
//
//   PURPOSE:	Set property value.
//
//
//
//   COMMENT:
//
//
//   
//
//                     Copyright (C) EuroSource AB 1992-1995
//************************************************************************* 

LONG NEAR SetProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{                
    switch (wp)
    {
                
            case IPROP_TOOL_BUTTONVALUE: 
            {
                LONG          i;
                LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                // handle VB TRUE
                if ((SHORT)lpDs->data == -1)
                    lpDs->data = 1;
                
                gb[i].Value = (SHORT)lpDs->data;
                
                // Handle group                    
                GroupUp(hctl, gb, (SHORT)i);                    
            
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
                InvalidateRect(hWnd, NULL, TRUE);  
                VBFireEvent(hctl, EVENT_TOOL_CLICK, NULL); 
            }
            return OK; 
            
            case IPROP_TOOL_BUTTONENABLED: 
            { 
                LONG          i; 
                LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                lpDs->data = (lpDs->data & 1);
                if (lpDs->data)
                    gb[i].Value = BUTTONUP;
                else
                    gb[i].Value = BUTTONDISABLED; 
            
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
                InvalidateRect(hWnd, NULL, TRUE);
            }
            return OK; 
            
            case IPROP_TOOL_BUTTONTOGGLED: 
            {
                LONG        i;
                LPDATASTRUCT lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                // handle VB's TRUE value
                if ((SHORT)lpDs->data == -1)
                    lpDs->data = 1;
                
                gb[i].fToggled = (BOOL)lpDs->data;
            
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
            }
            return OK;
                   
            case IPROP_TOOL_BUTTONALLUP: 
            {
                LONG        i;
                LPDATASTRUCT lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                // handle VB's TRUE value
                if ((SHORT)lpDs->data == -1)
                    lpDs->data = 1;
                
                gb[i].fAllUp = (BOOL)lpDs->data;
            
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
            }
            return OK;
            
            case IPROP_TOOL_BUTTONGROUP: 
            {
                LONG        i;
                LPDATASTRUCT lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                gb[i].Group = (SHORT)lpDs->data;
            
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
            }
            return OK;
            
            case IPROP_TOOL_BUTTONPICUP: 
            {
                LONG          i;
                LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL   gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                gb[i].hpicUp = (HPIC)lpDs->data;   
                
                // increase picture reference count
                VBRefPic((HPIC)lpDs->data);
                
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
                InvalidateRect(hWnd, NULL, TRUE);
            }
            return OK;                 
            
            case IPROP_TOOL_BUTTONPICDOWN: 
            {
                LONG          i;
                LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL   gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                gb[i].hpicDown = (HPIC)lpDs->data;
                
                // increase picture reference count
                VBRefPic((HPIC)lpDs->data);  
                
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
                InvalidateRect(hWnd, NULL, TRUE);
            }
            return OK;
                               
            case IPROP_TOOL_BUTTONPICDISABLED: 
            {
                LONG          i;
                LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
                PGLOBALTOOL   gb;
                
                gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);
                i = lpDs->index[0].data;
                
                gb[i].hpicDisabled = (HPIC)lpDs->data;
                
                // increase picture reference count
                VBRefPic((HPIC)lpDs->data);  
                
                GlobalUnlock(TOOLDEREF(hctl)->gButtons);
                InvalidateRect(hWnd, NULL, TRUE);
            }
            return OK;
            
            case IPROP_TOOL_CAPTION:
                // To avoid a Windows problem, make sure text is
                // under 255 bytes:
                if (lstrlen((LPSTR)lp) > 255)
                    *((LPSTR)lp + 255) = 0;
                break;
               
            case IPROP_TOOL_TITLEBAR:
            case IPROP_TOOL_MINBUTTON:
            case IPROP_TOOL_CONTROLBOX:
                if ((VBGetMode() == MODE_DESIGN) && (TOOLDEREF(hctl)->CCLoaded)) 
                {
                    recreate = TRUE;
                    VBRecreateControlHwnd(hctl);
                }                
                return OK;
            
            case IPROP_TOOL_LIGHT3DCOLOR:
            case IPROP_TOOL_DARK3DCOLOR:
                InvalidateRect(hWnd, NULL, TRUE);
                return(0L); 
                
                case IPROP_TOOL_WINDOWSTATE: 
                switch (LOWORD(lp)) 
                {
                	case    0:    
                    	ShowWindow(hWnd, SW_SHOWNORMAL);                          
                    	break;
                	case    1:
                    	ShowWindow(hWnd, SW_MINIMIZE);
                    	break;
                	case    2:
                    	ShowWindow(hWnd, SW_MAXIMIZE); 
                    	break;
                	default:
                    	return ERR_InvPropVal;
                }
                return OK;   
                          
                case IPROP_TOOL_BUTTONFOCUS:
                    InvalidateRect(hWnd, NULL, TRUE);
                    break; 
                
                case IPROP_TOOL_ROWS:
                case IPROP_TOOL_COLUMNS:
                case IPROP_TOOL_BUTTONWIDTH:
                case IPROP_TOOL_BUTTONHEIGHT:        
                    RecalcAreaTool(hctl, hWnd);
                    InvalidateRect(hWnd, NULL, TRUE);
                    break;
        }
		return VBDefControlProc(hctl, hWnd, msg, wp, lp);;                    
}

//**************************************************************************
//
//   FUNCTION:	LONG NEAR CheckProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)	
//
//   PURPOSE:	Check property value.
//
//
//
//   COMMENT:	
//
//
//   
//
//                     Copyright (C) EuroSource AB 1992-1995
//************************************************************************* 

LONG NEAR CheckProperty(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{                   
    PTOOL	ptool;
    
    switch (wp) 
    {   
    	case IPROP_TOOL_BUTTONVALUE: 
        {
        	LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
                    
            if (lpDs->index[0].data >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                    
            switch((SHORT)lpDs->data) 
            {
            	case BUTTONDOWN:
                case BUTTONUP:
                case BUTTONDISABLED:
                	return ERR_None;
                
                default:
                	return ERR_InvPropVal; 
            }                         
        }
        break;
                    
        case IPROP_TOOL_BUTTONENABLED:
        case IPROP_TOOL_BUTTONTOGGLED: 
        case IPROP_TOOL_BUTTONGROUP: 
        {
        	LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
                    
            if (lpDs->index[0].data >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
        }
        return ERR_None;    
                
        case IPROP_TOOL_BUTTONPICUP:
        case IPROP_TOOL_BUTTONPICDOWN:
        case IPROP_TOOL_BUTTONPICDISABLED: 
        {
        	LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;
            PIC		pic;
                    
            if (lpDs->index[0].data >= TOOL_MAXSIZE)
            	return ERR_BadIndex;
                
            VBGetPic((HPIC)lpDs->data, &pic);
            switch (pic.picType) 
            {
            	case PICTYPE_NONE:
                case PICTYPE_BITMAP:
                case PICTYPE_ICON:        
                	return ERR_None;
                
                default:
                    return ERR_InvPropVal; 
			}
		}
        break;                   
                
        case IPROP_TOOL_ICON: 
        {
        	PIC pic;

            VBGetPic((HPIC)lp, &pic);
            switch (pic.picType) 
            {
            	case PICTYPE_NONE:
                	return ERR_None;       
                
                case PICTYPE_ICON: 
                    SetClassWord(hWnd, GCW_HICON, pic.picData.icon.hicon);
                    return ERR_None;
                        
                default:
                return ERR_InvPropVal; 
       		}
       }
       break;
                
       	case IPROP_TOOL_COLUMNS:
       	case IPROP_TOOL_ROWS:
       		if ((SHORT)lp >= 1 && (SHORT)lp <=20)
            	return ERR_None;
            return ERR_InvPropVal;    
                
       	case IPROP_TOOL_BUTTONWIDTH:
       	case IPROP_TOOL_BUTTONHEIGHT:
       		if ((SHORT)lp > 0)
            	return ERR_None;
            else
                return ERR_InvPropVal;
                
      	case IPROP_TOOL_BUTTONFOCUS:
        	ptool = TOOLDEREF(hctl);
        	if ((SHORT)lp >= (ptool->Rows * ptool->Columns)) 
        		return ERR_InvPropVal;
            return ERR_None;        
            
        case IPROP_TOOL_PICTUREDRAWSTYLE:
        	if ((SHORT)lp < 0 || (SHORT)lp > TOOLDRAWSTYLEREPLACE)
            	return ERR_InvPropVal;
            return ERR_None;
	}
	return VBDefControlProc(hctl, hWnd, msg, wp, lp);;                
}

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawTool(HCTL hctl, HWND hWnd, HDC hDC)       
//
//      PURPOSE:    Draw the Tool     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawTool(HCTL hctl, HWND hWnd, HDC hDC)
{
    PTOOL  	ptool = TOOLDEREF(hctl);
    RECT	rectAll, rectButton, rectBFill;
    HBRUSH	hBrush, hGreyBrush, hOldBrush; 
    HDC		hdcOff;
    HBITMAP	hbmOff, hbmOldOff;
    int		ri, ci, xoffset, yoffset, ButtonIndex, nButtonFocus;
    PGLOBALTOOL gb;
    
    // lock up global storage
    gb = (PGLOBALTOOL)GlobalLock(ptool->gButtons); 
    
    // get button with focus
    nButtonFocus = ptool->ButtonFocus;
                             
    hGreyBrush = CreateSolidBrush(GREY); 
    
    // Fetch Background Brush
    hBrush = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR, hDC, MAKELONG(hWnd, 0));
    
    // get the clientarea
    GetClientRect(hWnd, &rectAll);
    
    // create an off screen dc and a bitmap big enough
    hdcOff = CreateCompatibleDC(hDC);
    hbmOff = CreateCompatibleBitmap(hDC, 
    			rectAll.right-rectAll.left,
                rectAll.bottom-rectAll.top);
    hbmOldOff = SelectObject(hdcOff, hbmOff);
    
    //Fill Background
    FillRect(hdcOff, &rectAll, hBrush);    
    
    hOldBrush = SelectObject(hdcOff, hGreyBrush);    
    xoffset = yoffset = 1;
	// print the tools
	for (ri=0;ri<TOOLDEREF(hctl)->Rows; ri++) 
    {
        rectButton.top = yoffset;
        rectButton.bottom = yoffset + ptool->ButtonHeight;
        xoffset = 1;
        for (ci=0;ci<TOOLDEREF(hctl)->Columns;ci++) 
        {
            rectButton.left = xoffset;
            rectButton.right = xoffset + ptool->ButtonWidth;
            ButtonIndex = ri*ptool->Columns + ci;
            FillRect(hdcOff, &rectButton, hGreyBrush);
            switch (gb[ri*ptool->Columns+ci].Value) 
            {
                case BUTTONUP: // not selected
            		DrawButton(hdcOff, &rectButton, ptool->Light3DColor, ptool->Dark3DColor);                                 
                	DrawPicture(hdcOff, (LPRECT)&rectButton, gb[ButtonIndex].hpicUp, ptool->PictureDrawStyle);
                	break;
                   
                case BUTTONDOWN:
                    DrawButton(hdcOff, &rectButton,ptool->Dark3DColor, ptool->Light3DColor);
                    DrawPicture(hdcOff, &rectButton, gb[ButtonIndex].hpicDown, ptool->PictureDrawStyle);
                    break;   
            	   
            	default:  
                    DrawButton(hdcOff, &rectButton, ptool->Light3DColor, ptool->Dark3DColor);
                    DrawPicture(hdcOff, &rectButton, gb[ButtonIndex].hpicDisabled, ptool->PictureDrawStyle);
            		break;
            }
        	// if this button has focus we should draw a focus rectangle
            if (nButtonFocus == ButtonIndex && hWnd == GetFocus())
            {   
                RECT	focusrect;
                
             	CopyRect(&focusrect, &rectButton);
				InflateRect(&focusrect,-2,-2);
				DrawFocusRect(hdcOff, &focusrect);     
			}
            
            CopyRect(&rectBFill, &rectButton);
        	xoffset += ptool->ButtonWidth+2;
        }
    	yoffset += ptool->ButtonHeight+2;               
    }                
    
    // blit offscreen stuff to screen
	BitBlt(hDC,
           0,
           0,
           rectAll.right-rectAll.left,
           rectAll.bottom-rectAll.top,
           hdcOff,
           0, 0, 
           SRCCOPY);
            
	SelectObject(hdcOff, hOldBrush);
    SelectObject(hdcOff, hbmOldOff);
    DeleteObject(hbmOff);
    DeleteDC(hdcOff);
    DeleteObject(hGreyBrush);
	GlobalUnlock(ptool->gButtons);
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR RecalcAreaTool(HCTL hctl, HWND hWnd);      
//
//      PURPOSE:    Use the hWnd's client size to determine the bounding 
//                  rectangle for the framepicture and associated stuff.     
//
//      COMMENTS:        
//
//      HISTORY:    920526AH Prehistory     
//
//**************************************************************************


VOID NEAR RecalcAreaTool(HCTL hctl, HWND hWnd)
{
    PTOOL   ptool = TOOLDEREF(hctl);
    RECT	rectAll, ptcrect, ptprect;
    SHORT	WidthAll;
    SHORT	HeightAll;
    
    // get the clientarea
    GetClientRect(hWnd, &rectAll);
	
	// construct the button rectangle
	ptool->rectButton.left = 0;
	ptool->rectButton.top = 0;
	ptool->rectButton.right = ptool->ButtonWidth;
	ptool->rectButton.bottom = ptool->ButtonHeight;
    
   	// adopt size for window
    WidthAll = ptool->Columns*(ptool->ButtonWidth)+(ptool->Columns-1)*2+5;
	HeightAll = ptool->Rows*(ptool->ButtonHeight)+(ptool->Rows)*2+3 + (ptool->TitleBar ? (GetSystemMetrics(SM_CYCAPTION)-1) : 0);
    GetWindowRect(hWnd, &ptcrect);
    GetWindowRect(GetParent(hWnd), &ptprect);
	MoveWindow(hWnd, ptprect.left-ptcrect.left, ptprect.top-ptcrect.top, WidthAll, HeightAll, TRUE); 
}    

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR MButtonDown(HCTL hctl, HWND hWnd, POINT pt);      
//
//      PURPOSE:    Handle a button down over a specific button
//                  
//
//      COMMENTS:        
//
//**************************************************************************

VOID NEAR MButtonDown(HCTL hctl, HWND hWnd, POINT pt)
{   
    PTOOL   	ptool = TOOLDEREF(hctl);
    WORD		index;
    PGLOBALTOOL	gb;
                       
    gb = (PGLOBALTOOL)GlobalLock(ptool->gButtons);
	index = GetButtonIndex(hctl, hWnd, pt);
    ptool->ButtonFocus = index;
    if (gb[index].Value != BUTTONDISABLED) 
    {
    	if (gb[index].fToggled) 
        {
            // only if AllUp enabled for this group
            if (gb[index].fAllUp) 
    			gb[index].Value = gb[index].Value ? BUTTONUP : BUTTONDOWN;
            else 
                gb[index].Value = BUTTONDOWN;
    	}       
		else 
        {
    		gb[index].Value = BUTTONDOWN;    
        	TOOLDEREF(hctl)->NonToggledDown = index+1;  // store current down index +1
    	}
    	// Handle Groups
    	GroupUp(hctl, gb, (SHORT)index);
    }    
	GlobalUnlock(ptool->gButtons);
}
    
//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR MButtonUp(HCTL hctl, HWND hWnd, POINT pt);      
//
//      PURPOSE:    Handle a button up over a specific button
//                  
//
//      COMMENTS:        
//
//**************************************************************************

VOID NEAR MButtonUp(HCTL hctl, HWND hWnd, POINT pt)
{ 
    PTOOL   	ptool = TOOLDEREF(hctl);
    WORD		index;
    PGLOBALTOOL	gb;
                       
    gb = (PGLOBALTOOL)GlobalLock(ptool->gButtons);
	index = GetButtonIndex(hctl, hWnd, pt);
    if (gb[index].Value != BUTTONDISABLED && !gb[index].fToggled)
    	gb[index].Value = BUTTONUP;
    	TOOLDEREF(hctl)->NonToggledDown = 0; // no button down
	GlobalUnlock(ptool->gButtons);
} 

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR MouseMove(HCTL hctl, HWND hWnd, POINT pt);      
//
//      PURPOSE:    If the mousepointer moves out of the ClientArea
// 					or moves to another button while a nontoggled
//					button is down we should release that button.
//                  
//
//      COMMENTS:        
//
//**************************************************************************  

VOID NEAR MouseMove(HCTL hctl, HWND hWnd, POINT pt)
{
    RECT	rc; 
    PGLOBALTOOL	gb;
                       
    gb = (PGLOBALTOOL)GlobalLock(TOOLDEREF(hctl)->gButtons);        
                        
    GetClientRect(hWnd, &rc);
    if (PtInRect(&rc, pt)) 
    {
    	// handle point on another button
    	if (TOOLDEREF(hctl)->NonToggledDown) 
        {
    		if ((TOOLDEREF(hctl)->NonToggledDown-1) != GetButtonIndex(hctl, hWnd, pt)) 
            {
        		gb[(TOOLDEREF(hctl)->NonToggledDown-1)].Value = BUTTONUP;
            	TOOLDEREF(hctl)->NonToggledDown = 0;        	            
        		InvalidateRect(hWnd, NULL, TRUE);
        	}        
    	}
    }
	else 
    {
        // outside of clientarea
        if (TOOLDEREF(hctl)->NonToggledDown) 
        {
    		gb[(TOOLDEREF(hctl)->NonToggledDown-1)].Value = BUTTONUP;
        	TOOLDEREF(hctl)->NonToggledDown = 0;        	            
        	InvalidateRect(hWnd, NULL, TRUE);     
    	}
    }    
	GlobalUnlock(TOOLDEREF(hctl)->gButtons);               
}
        
//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   SHORT NEAR GetButtonIndex(HCTL hctl, HWND hWnd, POINT pt);      
//
//      PURPOSE:    Handle a button down over a specific button
//                  
//
//      COMMENTS:        
//
//**************************************************************************

SHORT NEAR GetButtonIndex(HCTL hctl, HWND hWnd, POINT pt)
{   
    PTOOL   ptool = TOOLDEREF(hctl);
    RECT	rectAll;
    WORD	row,col;
    
    GetClientRect(hWnd, &rectAll);
    col = pt.x/(ptool->ButtonWidth+2);
    row = pt.y/(ptool->ButtonHeight+2);
	return (row*ptool->Columns+col);
} 


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR GroupUp(HCTL hctl, PGLOBALTOOL gb, SHORT index);      
//
//      PURPOSE:    Handle button Groups.
//                  
//
//      COMMENTS:        
//
//**************************************************************************

VOID NEAR GroupUp(HCTL hctl, PGLOBALTOOL gb, SHORT index)    
{
    SHORT	j;
    
    // handle group's
    if (gb[index].Value == BUTTONDOWN && gb[index].Group) 
    {
    	for(j=0;j<TOOL_MAXSIZE;j++) 
        {
        	if (j != index) 
            {
            	if (gb[index].Group == gb[j].Group && gb[j].Value != BUTTONDISABLED)
                	gb[j].Value = BUTTONUP;
            }
        }
    }                                           
}    

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawPicture(HDC hDC, LPRECT lprect, HPIC hpic, int drawstyle);      
//
//      PURPOSE:    Draws a picture in Up/Down or its Disabled state.
//                  
//
//      COMMENTS:   DRAWSTYLE  (only used for bitmaps)
//						TOOLDRAWSTYLESTRETCHED - stretch to fit in button
//						TOOLDRAWSTYLEINBUTTON  - blit into button
//						TOOLDRAWSTYLEREPLACE   - replace entire button     
//
//**************************************************************************

VOID NEAR DrawPicture(HDC hDC, LPRECT lprect, HPIC hpic, int drawstyle)
{                     
			PIC		pic;
            HDC		hdcMem;
            BITMAP	bmp;
            RECT	rectPic;
            
            // copy bitmap rectangle
            CopyRect(&rectPic, (LPRECT)lprect);
            switch(drawstyle) 
            {
                case TOOLDRAWSTYLESTRETCHED:
                    InflateRect(&rectPic, -2, -2);
                    break;  
                
                case TOOLDRAWSTYLEREPLACE:
                    // do nothing
                    break;
                
            	case TOOLDRAWSTYLEINBUTTON:
                    InflateRect(&rectPic, -2, -2);
                    break;
            }             
        
            VBGetPic((HPIC)hpic, &pic);            
            
            switch (pic.picType) 
            {
            	case PICTYPE_BITMAP: 
                    GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
                	hdcMem = CreateCompatibleDC(hDC);
                	SelectObject(hdcMem, pic.picData.bmp.hbitmap);
                	StretchBlt(hDC, rectPic.left, rectPic.top,
                		rectPic.right - rectPic.left,
                		rectPic.bottom - rectPic.top,
                		hdcMem, 0, 0, bmp.bmWidth, bmp.bmHeight,
                		SRCCOPY);               
                    DeleteDC(hdcMem);
                	break;    
            
            	case PICTYPE_ICON:
            		DrawIcon(hDC,                               
                		lprect->left+(lprect->right-lprect->left-36)/2+2,
                		lprect->top+(lprect->bottom-lprect->top-36)/2+2,
                		pic.picData.wmf.hmeta);
            		break;
			}
}
