//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         Tools.h
//   
// PURPOSE:      Header file for TOOLS subclass EuroCtrl project
//   
// COMMENTS:     
//   
//****************************************************************************                    



#define TOOL_BACKGROUND_DEFAULT    BLACK

#define TOOL_DEFAULTROWS			1
#define TOOL_DEFAULTCOLUMNS			5

#define TOOL_MAXROWS 				20
#define TOOL_MAXCOLUMNS				20
#define TOOL_MAXSIZE				TOOL_MAXROWS*TOOL_MAXCOLUMNS

#define TOOL_BUTTON_DEFAULTHEIGHT	34
#define TOOL_BUTTON_DEFAULTWIDTH	34

//---------------------------------------------------------------------------
// TOOL control data and structs
//---------------------------------------------------------------------------
typedef struct tagGLOBALTOOL
{        
	HPIC	hpicUp;  		// handel to up button picture
	HPIC	hpicDown;		// handle to down button picture
	HPIC	hpicDisabled;	// handle to diabled button picture
	SHORT	Group;			// group belonging for button
	SHORT	Value;	    	// TRUE if down/FALSE if up/$FF disabled.
    BOOL	fToggled;       // TRUE if button should be of toggle type 
    BOOL	fAllUp;			// TRUE if all buttons in a group allowed to be up
	
} GLOBALTOOL;

typedef GLOBALTOOL FAR * PGLOBALTOOL;
                            
#define	BUTTONUP			0
#define	BUTTONDOWN			1
#define BUTTONDISABLED		2

//---------------------------------------------------------------------------
// TOOL control data and structs
//---------------------------------------------------------------------------
typedef struct tagTOOL
{                     
    HSZ		hszabout;
    HFONT   hfont;          // CaptionFont
    HSZ     hszCaption;     // handle to Caption String
    LONG    Light3DColor;   // 3D lines Light Color
    LONG    Dark3DColor;    // 3D Lines Dark Color 
	BOOL	TitleBar;		// TRUE if titlebar
	BOOL	MinButton;		// TRUE if minbutton
	BOOL	ControlBox;		// TRUE if controlbox 
	HPIC	Icon;			// Icon when minimized
	SHORT	WindowState;	// minimized/maximized etc
	BOOL	CCLoaded;		// properties loaded
	SHORT	Columns;		// number of columns 1-20
	SHORT	Rows;			// number of rows 1-20 
	GLOBALHANDLE gButtons;	// global handle to button information
	RECT	rectButton;		// size for the buttons
	SHORT	ButtonWidth;    // Width of button
	SHORT	ButtonHeight;	// Height of button
	ENUM	PictureDrawStyle; // How a bitmap is drawn
	SHORT	ButtonFocus;	// tell wish button got focus
	SHORT	NonToggledDown;	// Internal: index+1 for nontoggled button thats down
} TOOL;

typedef TOOL FAR * PTOOL;

#define TOOLDEREF(hctl)     ((PTOOL)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export ToolsCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_TOOL_NAME           	0
#define IPROP_TOOL_INDEX           	1
#define IPROP_TOOL_PARENT          	2
#define IPROP_TOOL_BACKCOLOR       	3
#define IPROP_TOOL_LEFT            	4
#define IPROP_TOOL_TOP             	5
#define IPROP_TOOL_WIDTH           	6
#define IPROP_TOOL_HEIGHT          	7
#define IPROP_TOOL_ENABLED         	8
#define IPROP_TOOL_VISIBLE         	9
#define IPROP_TOOL_MOUSEPOINTER    	10
#define IPROP_TOOL_CAPTION         	11
#define IPROP_TOOL_FONTNAME        	12
#define IPROP_TOOL_FONTSIZE        	13
#define IPROP_TOOL_FONTBOLD        	14
#define IPROP_TOOL_FONTITALIC      	15
#define IPROP_TOOL_FONTSTRIKE      	16
#define IPROP_TOOL_FONTUNDER       	17
#define IPROP_TOOL_DRAG            	18
#define IPROP_TOOL_DRAGICON        	19
#define IPROP_TOOL_TABINDEX        	20
#define IPROP_TOOL_TABSTOP         	21
#define IPROP_TOOL_TAG             	22
#define IPROP_TOOL_LIGHT3DCOLOR    	23
#define IPROP_TOOL_DARK3DCOLOR     	24
#define IPROP_TOOL_FORECOLOR       	25 
#define IPROP_TOOL_ABOUT		   	26 
#define IPROP_TOOL_TITLEBAR			27
#define IPROP_TOOL_MINBUTTON		28
#define IPROP_TOOL_CONTROLBOX		29
#define IPROP_TOOL_ICON				30
#define IPROP_TOOL_WINDOWSTATE		31
#define IPROP_TOOL_COLUMNS			32
#define IPROP_TOOL_ROWS				33
#define IPROP_TOOL_BUTTONWIDTH		34
#define IPROP_TOOL_BUTTONHEIGHT		35
#define IPROP_TOOL_PICTUREDRAWSTYLE	36
#define IPROP_TOOL_GLOBAL			37
#define IPROP_TOOL_BUTTONVALUE		38
#define IPROP_TOOL_BUTTONENABLED	39
#define IPROP_TOOL_BUTTONPICUP		40
#define IPROP_TOOL_BUTTONPICDOWN	41
#define IPROP_TOOL_BUTTONPICDISABLED 42
#define IPROP_TOOL_BUTTONTOGGLED	43
#define IPROP_TOOL_BUTTONGROUP		44
#define IPROP_TOOL_BUTTONFOCUS		45
#define IPROP_TOOL_BUTTONALLUP		46 
#define IPROP_TOOL_HWND				47

#ifdef CTL_DATA                       

PROPINFO Property_Tools_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(TOOL, hszabout)
}; 

PROPINFO propinfoToolsLight3DColor =
{
    "Light3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,Light3DColor), 0,
	WHITE
};

PROPINFO propinfoToolsDark3DColor =
{
    "Dark3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,Dark3DColor), 0,
	DARKGREY
};

PROPINFO propinfoToolsTitleBar =
{
    "TitleBar",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fPreHwnd | PF_fNoRuntimeW | PF_fDefVal,
    OFFSETIN(TOOL,TitleBar), 0,
	FALSE
};   
     
PROPINFO propinfoToolsMinButton =
{
    "MinButton",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fPreHwnd | PF_fNoRuntimeW | PF_fDefVal,
    OFFSETIN(TOOL,MinButton), 0,
	FALSE
};   
                      
PROPINFO propinfoToolsControlBox =
{
    "ControlBox",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fPreHwnd | PF_fNoRuntimeW | PF_fDefVal,
    OFFSETIN(TOOL,ControlBox), 0,
	FALSE
};

PROPINFO propinfoToolsIcon =
{
    "Icon",
    DT_PICTURE | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(TOOL,Icon), 0,
	0
};  
      
PROPINFO propinfoToolsWindowState =
{
    "WindowState",
    DT_SHORT | PF_fGetMsg | PF_fSetMsg | PF_fNoShow | PF_fNoShow | PF_fDefVal,
    OFFSETIN(TOOL,WindowState), 0,
	0
};
    
PROPINFO propinfoToolsColumns =
{
    "Columns",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fNoRuntimeW | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,Columns), 0,
	TOOL_DEFAULTCOLUMNS
};

PROPINFO propinfoToolsRows =
{
    "Rows",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fNoRuntimeW | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,Rows), 0,
    TOOL_DEFAULTROWS
}; 
 
PROPINFO propinfoToolsButtonWidth =
{
    "ButtonWidth",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fNoRuntimeW | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,ButtonWidth), 0,
	TOOL_BUTTON_DEFAULTWIDTH
};

PROPINFO propinfoToolsButtonHeight =
{
    "ButtonHeight",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fNoRuntimeW | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,ButtonHeight), 0,
	TOOL_BUTTON_DEFAULTHEIGHT
};                

#define	TOOLDRAWSTYLESTRETCHED	0
#define TOOLDRAWSTYLEINBUTTON	1
#define TOOLDRAWSTYLEREPLACE    2

PROPINFO propinfoToolsPictureDrawStyle =
{
    "PictureDrawStyle",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,PictureDrawStyle), 0,
    TOOLDRAWSTYLESTRETCHED,
	"0 - Fit in button.\0"
	"1 - In button.\0"
	"2 - Replace button.\0",
	TOOLDRAWSTYLEREPLACE,
};
     
// * * * * DUMMY FOR LOADING SAVING GLOBAL DATA * * * *

PROPINFO propinfoToolsGlobal =
{
    "Global",
    DT_BOOL | PF_fSaveMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};

PROPINFO propinfoToolsButtonValue =
{
    "ButtonValue",
    DT_SHORT | PF_fSetMsg | PF_fSetCheck | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
};     

PROPINFO propinfoToolsButtonEnabled =
{
    "ButtonEnabled",
    DT_BOOL | PF_fSetMsg | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
};
                  
PROPINFO propinfoToolsButtonPicUp =
{
    "ButtonPicUp",
    DT_PICTURE | PF_fSetMsg | PF_fSetCheck | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
};

PROPINFO propinfoToolsButtonPicDown =
{
    "ButtonPicDown",
    DT_PICTURE | PF_fSetMsg | PF_fSetCheck | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
};
                  
PROPINFO propinfoToolsButtonPicDisabled =
{
    "ButtonPicDisabled",
    DT_PICTURE | PF_fSetMsg | PF_fSetCheck | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
};

PROPINFO propinfoToolsButtonToggled =
{
    "ButtonToggled",
    DT_BOOL | PF_fSetMsg | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
}; 
    
PROPINFO propinfoToolsButtonGroup =
{
    "ButtonGroup",
    DT_SHORT | PF_fSetMsg | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
}; 

PROPINFO propinfoToolsButtonFocus =
{
    "ButtonFocus",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(TOOL,ButtonFocus), 0,
	0
};
 
PROPINFO propinfoToolsButtonAllUp =
{
    "ButtonAllUp",
    DT_BOOL | PF_fSetMsg | PF_fGetMsg | PF_fPropArray | PF_fNoShow,
    0, 0
};           

PROPINFO propinfoToolshWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
}; 

PPROPINFO proplistTools[] =
{
    PPROPINFO_STD_NAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_TAG,
    &propinfoToolsLight3DColor,
    &propinfoToolsDark3DColor,
    PPROPINFO_STD_FORECOLOR,
    &Property_Tools_About,
    &propinfoToolsTitleBar,
    &propinfoToolsMinButton,
    &propinfoToolsControlBox, 
    &propinfoToolsIcon,
    &propinfoToolsWindowState,
    &propinfoToolsColumns,
    &propinfoToolsRows,
    &propinfoToolsButtonWidth,
    &propinfoToolsButtonHeight,
    &propinfoToolsPictureDrawStyle,                   
    &propinfoToolsGlobal,
    &propinfoToolsButtonValue,
    &propinfoToolsButtonEnabled,
    &propinfoToolsButtonPicUp,
    &propinfoToolsButtonPicDown,
    &propinfoToolsButtonPicDisabled,
    &propinfoToolsButtonToggled,      
    &propinfoToolsButtonGroup,
    &propinfoToolsButtonFocus,
    &propinfoToolsButtonAllUp,
    &propinfoToolshWnd, 
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_TOOL_CLICK		0	
#define EVENT_TOOL_DRAGDROP    	1
#define EVENT_TOOL_DRAGOVER    	2
#define EVENT_TOOL_GOTFOCUS		3
#define EVENT_TOOL_KEYDOWN		4
#define EVENT_TOOL_KEYPRESS		5
#define EVENT_TOOL_KEYUP		6
#define EVENT_TOOL_LOSTFOCUS	7

#ifdef CTL_DATA
PEVENTINFO eventlistTools[] =
{
    PEVENTINFO_STD_CLICK,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    PEVENTINFO_STD_GOTFOCUS,
    PEVENTINFO_STD_KEYDOWN,
    PEVENTINFO_STD_KEYPRESS,
    PEVENTINFO_STD_KEYUP,
    PEVENTINFO_STD_LOSTFOCUS,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelTools =
{
    VB_VERSION,                 // VB version being used
    MODEL_fDesInteract |        // MODEL flags
    MODEL_fInitMsg |
    MODEL_fFocusOk |
    MODEL_fArrows  |
    MODEL_fLoadMsg,
    (PCTLPROC)ToolsCtlProc,     // Control procedure
    CS_VREDRAW | CS_HREDRAW,    // Class style
    WS_BORDER,                  // Default Window style
    sizeof(TOOL),               // cbCtlExtra for TOOL structure
    IDBMP_TOOL,                 // Palette bitmap ID
    "EsTools",		            // Default control name
    "EsTools",		            // Visual Basic class name
    NULL,                   	// Parent class name
    proplistTools,              // Properties list
    eventlistTools,             // Events list
	IPROP_TOOL_BUTTONFOCUS,     // default property
	EVENT_TOOL_CLICK,			// defeualt event
	IPROP_TOOL_BUTTONFOCUS		// standard propert
};
#endif  // CTL_DATA

LPMODEL modellistTools[] =
    {
    &modelTools,
    NULL
    };

MODELINFO modelinfoTools =
    {
    VB_VERSION, 			// VB version being used
    modellistTools			// MODEL list
    };

#endif  // RC_INVOKED
